/*
 * Copyright (c) 2017 Akitsugu Komiyama
 * under the MIT License
 */

#define _CRT_SECURE_NO_WARNINGS
#include "hm_filter.h"

using namespace std;

HGLOBAL utf16_to_hm_filter_global(const wstring& wstr_text) {
	// wstring^Ȃ̂ŁAKQ{B
	size_t cb = (wstr_text.length() + 1) * 2;

	HGLOBAL	hmemDst = GlobalAlloc(GMEM_MOVEABLE, cb);
	if (hmemDst == nullptr) {
		MessageBox(NULL, L"\mۂłȂ", L"\mۂłȂ", NULL);
		return nullptr;
	}

	// bN
	wchar_t* pwchDest = (wchar_t*)GlobalLock(hmemDst);
	// Rsy
	wcscpy(pwchDest, wstr_text.c_str());
	// AbN
	GlobalUnlock(pwchDest);
	return pwchDest;
}


//---------------------------------------------------------------------------------------------------
// ʂ̃o[Wl  GەϊW[^Cṽo[Wɕϊ
//---------------------------------------------------------------------------------------------------
int double_ver_to_hm_filter_ver(const double ver) {
	// }Ci[o[Woāc
	double minor = ver - (int)ver;

	// W[o[Wo
	int major = int(ver - minor);

	// Gۂ~`ւƕϊ
	return (major << 16) + int(100 * minor);
}
